/*
 * Proxy URLs - simple example for Google Scholar.
 *
 * 		Art Rhyno (arhyno@uwindsor.ca), November 2004
 *		(c) 2004 Art Rhyno
 *
 *	addOpenURLs function added by Peter Binkley (peter.binkley@ualberta.ca)
 *  (c) 2004 Peter Binkley 
 *	
 * 		Revised: 2004-02-02 - added addOpenURLs function
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

//you need to change this value for your proxy setup!
var proxy_address = 'http://login.ezproxy.library.ualberta.ca/login?url=';

// OpenURL variables
var baseurl = "http://resolver.library.ualberta.ca/resolver"; // base url of the link resolver (no ? at end)
var button = "http://resolver.library.ualberta.ca/resolver-templates/gifs/getit.gif";
var sid = "ualberta:googlescholaropenurl";
var alttext = "Get It!"; // for alt attribute for button


//this string indicates a Google URL to be changed
var check_str = '/url?q=';

//cleanValue - make sure there is no funny characters in a string
function cleanValue(inStr) {
	var testChar = '';
	var returnString = "";
	for (i = 0; i < inStr.length; i++) {
		testChar = inStr.charAt(i);
		var lastChar = returnString.length;
		if (lastChar > 0)
			lastChar--;
		if (testChar >= '0' && testChar <= 'z') {
			returnString = returnString + testChar;
		} else {
			if (returnString.charAt(lastChar) != ' ')
				returnString = returnString + ' ';
		}
	}//for
	return returnString;
}//cleanValue

//encodeLink - if you had a really convoluted proxy setup, this
//		would be a good idea
function encodeLink(stringIn) {
	var newLink = stringIn.replace(/\?/gi,"%3F");

	newLink = zapLastSlash(newLink);

	newLink = newLink.replace(/&/gi,"%26");
	newLink = newLink.replace(/=/gi,"%3D");
	newLink = newLink.replace(/\+/gi,"%2B");
	newLink = newLink.replace(/\(/gi,"%28");
	newLink = newLink.replace(/\)/gi,"%29");

	if (newLink.indexOf('http://') != 0)
		newLink = currentUrl + newLink;

	return newLink;
}//encodeLink

//constructor for URL information
function URLinfo(theURL) {
	this.URL = theURL;
	this.name = '';
	this.linkNode = null;
	this.node = null;
}//URLinfo


//nodeWalker - walk through page DOM looking for matches
function nodeWalker(node,tag){
	window.status = "Looking...";
	var nodeStatus = 0, pos = 0;
	var nodeString = node.nodeValue + '';
	var nodeStrLen = nodeString.length;


	if (str.length > 1 && !matched) {
		if (matchStr.indexOf(str) != -1) 
			matched = true;
	}	

	if(nodeStrLen > 0  && node.nodeType==TEXT_NODE){
		if (collectURL) {
			theURLs[theURLs.length - 1].name = 
				cleanValue(nodeString);	
			window.status = "-> " + 
				theURLs[theURLs.length - 1].name;
			theURLs[theURLs.length - 1].node = node;		
			collectURL = false;
		}
		if (str.length > 1 && !matched) {
			matchStr = cleanValue(matchStr + 
				nodeString);
		}
	} else if ((node.nodeType==ELEMENT_NODE || 
		node.nodeName=="#document") && 
		node.childNodes)
	{
		if (node.nodeType==ELEMENT_NODE && 
			tag.indexOf(node.nodeName) != -1) 
		{
			var attrNode = node.getAttributeNode('HREF');
			var checkURL = attrNode.nodeValue.indexOf(check_str);
			if (checkURL != -1) {
				theURLs[theURLs.length] = new URLinfo(attrNode.
					nodeValue.substring(check_str.length));
				theURLs[theURLs.length - 1].linkNode = node;

				attrNode = node.getAttributeNode('ALT');
				if (attrNode != null && !matched) {
					theURLs[theURLs.length - 1].name = 
						attrNode.nodeValue;
				} else
					collectURL = true;		
			}
		}
		for(var child=0;child<node.childNodes.length;++child)
			child=child+nodeWalker(node.childNodes[child],tag);
	}//if node
	window.status="";
	return nodeStatus;
}//nodeWalker

//frameWalker - loop through frames, Google probably would never
//		use them, but just to be safe...
function frameWalker(thisFrame) {

	var theFrame = thisFrame;

	for (var i=0;i < theFrame.frames.length;i++) {
		try { 
			//flush out errors
			var thisTest = theFrame.frames[i].document.body;
			var testDocument = theFrame.frames[i].document;
			thisDocument = testDocument;
			nodeWalker(testDocument,'A',str);
			if (theFrame.frames[i].frames.length > 0) {
				frameWalker(testDocument);
			}
		} catch(er) {
			//alert("error " + er);
			thisDocument = document;
			return false;
		}//try
	}//for
	return true;
}//frameWalker

//workWithNodes - this briefly changes URLs to yellow, which we
//			don't probably need here, but will when
//			if we check proxy file
function workWithNodes(thisNode) {
	var middleBit = thisNode.node.splitText(0);
	var thisLinkNode = thisNode.linkNode;
	var theName = thisNode.name + ' (proxied)';
	var theURL = thisNode.URL;
	var parent = middleBit.parentNode;

	var spanNode=document.createElement('SPAN'); 
	spanNode.style.backgroundColor = "yellow";

	spanNode.id='proxy_' + count;
	var middleClone= middleBit.cloneNode(true);
	spanNode.appendChild(middleClone);
	
	parent.replaceChild(spanNode,middleBit);

	var linkNode = document.createElement('a');
	linkNode.setAttribute("target",'_blank');
	linkNode.setAttribute("href",proxy_address + theURL);
	linkNode.appendChild(document.createTextNode(
		theName));

	var thislink = document.createTextNode('yoyo');

	try {
		document.getElementById('proxy_' + count++).parentNode.
			replaceChild(thislink,spanNode);
		thisLinkNode.parentNode.
			replaceChild(linkNode,thisLinkNode);


	} catch (er) {
		alert('unable to change URL for' +
			thisNode.name);
	}	
}//workWithNodes

function addOpenURLs() {

//var document = window._content.document; 
	if (document.location.href.indexOf("scholar.google.") != -1) {
	// this is a Google Scholar page

		// work through the hits, each of which is in a p element
		var hits = document.getElementsByTagName("p");
		for (var i = 0; i < hits.length; i++) {
			var p = hits[i];
			
			// get article title out of the link (if any)
			// link is in span tag with class=w
			var spans = p.getElementsByTagName("span");
			// if there is no span, there's no title link, so we don't want an openurl
			if (spans.length) {
				// grab the contents of the first a in the first span, and strip tags
				// (since the search term is in b tags)
				var atitle = spans[0].getElementsByTagName("a")[0].innerHTML.replace(/(<([^>]+)>)/ig,"");
			
				// now let's get the author from the first green font bit
				var j = 0;
				var fonttags = p.getElementsByTagName("font");
				var author = "";
				while (author == "") {

					if (fonttags[j]) {
						//alert(j + ": " + fonttags[j].getAttribute("color") + ": " + fonttags[j].innerHTML);
						if ((fonttags[j].getAttribute("color") == 'green') || 
							(fonttags[j].getAttribute("color") == '#008000')) {
								// note: IE translates color attributes from names to numbers
							author = fonttags[j].innerHTML;			
						}
						else 
							j++;
					}
					else 
						break;
				}
				// reduce to first author by truncating at comma
				j = author.indexOf(',');
				if (j >= 0) {
					author = author.substring(0, j);
				}
				// now separate the initials
				j = author.indexOf(' ');
				var init = "";
				if (j >= 0) {
					init = author.substring(0, j);
					author = author.substring(j + 1, author.length);
				} 

			
				// first, we need to retrieve the last green font tag
				// we grab the content of each green font tag in turn, so that 
				// each one replaces the last one - so we'll be left with the 
				// contents of the final one
				var citation = "";
				for (j = 0; j < fonttags.length; j++) {
					// we want green font tags that are direct children of a font tag
						if (((fonttags[j].getAttribute("color") == 'green') || 
							(fonttags[j].getAttribute("color") == '#008000')) &&
					 (fonttags[j].parentNode.nodeName == 'FONT')) {
					// get value of first node - if we're in the last green font tag, 
					// the first child must be the text before the links
						citation = fonttags[j].childNodes[0].nodeValue;
					}
				} // end fonttags loop

				// now parse the citation
				// remove everything after the -
				j = citation.indexOf('-');
				if (j >= 0)
					citation = citation.substring(0, j-1);			
				// now grab the year
				j = citation.indexOf(',');
				var year = "";
				if (j >= 0) {
					year = citation.substring(j+2, j+6);
					citation = citation.substring(0, j);
				}
				// now build the openurl
				openurl = "sid=" + sid + "&genre=article&title=" + escape(citation);
				if (year != "")
					openurl += "&date=" + year;
				openurl += "&atitle=" + escape(atitle); 
				if (author != "")
					openurl += "&aulast=" + author + "&auinit=" + init;

				// finally, build the link	
				var openurllink = document.createElement("a");
  	    openurllink.setAttribute("href", baseurl + '?' + openurl);
  			openurllink.setAttribute("target", '_new');
	    	openurllink.innerHTML = "<img style='border: 0px;'  src='" + button + 
					"' alt='" + alttext +"'>";
				p.appendChild(document.createElement("br"));
  	    p.appendChild(openurllink);		
			} // end "if spans"
		} // end hits loop
	}// end "if scholar.google"

}// addOpenURLs

//global variables
var	ELEMENT_NODE	= 1;
var	TEXT_NODE	= 3;

var 	collectURL	= false;
var	matched		= false;

var 	theURLs = new Array();

var currentUrl = document.URL;

var matchStr = '';

var str = '';

var count = 0;

var currentUrl = document.location;


if (parent.window.document.getSelection) {
    str = parent.window.document.getSelection();
} else if (parent.window.document.selection && 
	parent.window.document.selection.createRange) 
{
    var range = parent.window.document.selection.createRange();
    str = range.text;
}

str = cleanValue(str);
  
window.status="linking, please wait...";

if (parent.window.frames.length > 1) {
	if (!frameWalker(parent.window))
		nodeWalker(document.body,'A',str);
} else
	nodeWalker(document.body,'A',str);

	//note: must add openurls before doing proxying, otherwise the word "proxied"
	// gets harvested as part of the article title
 addOpenURLs();	
	
for(var i=0;i < theURLs.length;i++)
	workWithNodes (theURLs[i]);
  
